/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Trace
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.kernel.trace;

import java.util.ArrayList;
import org.w3c.dom.Document;

import jp.co.ntt.lms.lo.scorm.kernel.exception.SystemException;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;

/**
* Trace クラス<BR>
* トレースログ操作クラス<BR>
*/
public class Trace {

	/** トレースリスト */
	private ArrayList traceItemList;

	/** ログ出力トレースアイテム */
	private TraceItem log;

	/** Trace Document */
	private Document doc;

	/** DefaultTraceItemクラス名 */
	public static final String NO_CONDITION_TRACE_ITEM = "NoConditionTraceItem";

	/** NavigateTraceItemクラス名 */
	public static final String NAVIGATE_TRACE_ITEM = "NavigateTraceItem";

	/** BehaviorTraceItemクラス名 */
	public static final String BEHAVIOR_TRACE_ITEM = "BehaviorTraceItem";

	/** EvaluateRuleTraceItemクラス名 */
	public static final String EVALUATE_RULE_TRACE_ITEM = "EvaluateRuleTraceItem";

	/** EditActivityInformationTraceItemクラス名 */
	public static final String EDIT_ACTIVITY_INFORMATION_TRACE_ITEM = "EditActivityInformationTraceItem";

	/** LimitCondiitionRuleTraceItemクラス名 */
	public static final String LIMIT_CONDITION_RULE_TRACE_ITEM = "LimitCondiitionRuleTraceItem";

	/** LimitCondiitionTraceItemクラス名 */
	public static final String LIMIT_CONDITION_TRACE_ITEM = "LimitCondiitionTraceItem";

	/** SelectRandomizeTraceItemクラス名 */
	public static final String SELECT_RANDOMIZE_TRACE_ITEM = "SelectRandomizeTraceItem";

	/**
	 * コンストラクタ<BR>
	 */
	public Trace() {
		clearTrace();
	}

	/**
	 * トレース情報初期化
	 */
	public void clearTrace() {
		traceItemList = new ArrayList();
		log = null;
	}

	/**
	 * トレース開始<BR>
	 * endTraceと対で使用すること<BR>
	 * トレース中に新たなトレースを開始した場合は子ノードとしてトレースログが出力される<BR>
	 * 新しいトレースアイテムをカレントトレースアイテムとして追加する<BR>
	 * 開始した全てのトレースが正常に終了していない場合はgetTraceLogできない<BR>
	 * ルートのトレースを終了させた場合、新しいトレースの開始はできない<BR>
	 * @param traceElementName トレースログのエレメントを設定<BR>
	 * @return 新規に生成したカレントトレースアイテムクラスを返却<BR>
	 */
	public TraceItem startTrace(String traceElementName) throws SystemException {

		try {

			if (log != null) {
				throw new SystemException("トレースは既に完了しています。");
			}
			if (traceItemList.size() == 0) {
				doc = XMLUtil.createDocument(traceElementName, false);
			}
			TraceItem traceItem = null;
			traceItem = new TraceItem(traceElementName);
			traceItemList.add(traceItem);
			return traceItem;
		}
		catch (SystemException e) {
			throw e;
		}
		catch (Exception e) {
			throw new SystemException("トレース開始に失敗しました。",e);
		}
	}

	/**
	 * カレントトレースアイテム返却<BR>
	 * メソッドをまたいで同じトレースアイテムを使用したい場合に使用<BR>
	 * どのトレースアイテムが使用されているかは使用者が制御のこと<BR>
	 * @return 最下トレースアイテム
	 */
	public TraceItem getCurrentTraceItem() {
		return (TraceItem)traceItemList.get(traceItemList.size() - 1);
	}

	/**
	 * トレースドキュメント返却返却<BR>
	 * @return トレースドキュメント
	 */
	public Document getTraceDocument() {
		return doc;
	}

	/** 
	 * トレース終了<BR>
	 * finally句中に記述し、開始したトレースは必ず終了させること<BR>
	 * カレントトレースアイテムは親のトレースアイテム中に保存して終了<BR>
	 * カレントトレースアイテムは親に移動<BR>
	 */
	public void endTrace() throws SystemException {

		try {
			if (traceItemList.size() == 0) {
				throw new SystemException("トレースを開始していません。");
			}
			else if (traceItemList.size() == 1) {
				if (log != null) {
					throw new SystemException("トレースは全て完了しています。");
				}
				// ログ出力用トレースアイテム設定
				log = (TraceItem)traceItemList.get(0);
			}
			else {
				// トレース中アイテムから最下トレースアイテムを削除
				TraceItem currentItem = (TraceItem)traceItemList.get(traceItemList.size() - 1);
				TraceItem parentItem = (TraceItem)traceItemList.get(traceItemList.size() - 2);
				if (currentItem.isValid()) {
					// 子トレースアイテムを親トレースアイテムに保存
					parentItem.appendChild(currentItem);
				}
				traceItemList.remove(traceItemList.size() - 1);
			}
		}
		catch (SystemException e) {
			throw e;
		}
	}

	/**
	 * トレース結果を返却<BR>
	 * @return 生成したDOM Document
	 */
	public Document getTraceLog() throws SystemException {

		try {
			// トレースログ開始済み判定
			if (traceItemList.size() == 0) {
				throw new SystemException("トレースが開始していません。");
			}
			// 子トレースログ終了済み判定
			if (traceItemList.size() > 1) {
				throw new SystemException("幾つかのトレースが終了していません。");
			}
			// トレースログ終了済み判定
			if (log == null) {
				throw new SystemException("トレースが終了していません。");
			}
			if (log.isValid())
				// トレースアイテムのDOM Documentを返却
				return log.getXMLDocument(doc);
			else {
				// ルートトレースアイテムが出力対象でない場合nullを返却
				return null;
			}
		}
		catch (SystemException e) {
			throw e;
		}
	}
}
